{ ------------------------------------------------------------- }
{                                                               }
{   Name:           XBackCtl.pas                                }
{   Version:        V 0.1                                       }
{   Author:         Erick I. Jimenez Alvarado                   }
{   To contact:     erickj@usa.net                              }
{                   http://members.xoom.com/erickj              }
{                                                               }
{   Description:    Class Gradient Fill                         }
{                                                               }
{   File Status:    COMPONETWARE ( like a FREEWARE but if you   }
{                   make a Componet or modify this please       }
{                   send or e-mail me this).                    }
{                                                               }
{   Last Upadated:  02/01/99                                    }
{                                                               }
{   History:                                                    }
{                                                               }
{    01/18/99   V0.1 -  First relase version. Cool.             }
{                                                               }
{   Finally:        Sorry my bad, bad english and thanks for    }
{                   use my component.                           }
{                                                               }
{ ------------------------------------------------------------- }

{.$DEFINE PRG_UNIT}

{$IFDEF PRG_UNIT}               { ---------------------- }

{$DEFINE PRG_INTERFACE}
{$DEFINE PRG_IMPLEMENTATION}

{$I XTools.Inc } { Directives for all controls }

unit XBackCtl;

interface

uses

 {$IFNDEF WIN32}
    WinTypes, WinProcs,             { Default Units }
 {$ELSE}
    Windows,                        { Default Unit  }
 {$ENDIF}  { // WIN32 }


  Graphics, Controls, Classes,

  GraphExt,                         { My Unit       }

  XObjects, XCtrlCls;               { My Unit       }

{$ENDIF} { // PRG_UNIT }


{$IFDEF PRG_INTERFACE}          { ---------------------- }

type

{
// --------------------------------------------------------
//  Gradient Control Class
// --------------------------------------------------------
}

  TBackground = class(TEnhTextureControl)
  private

    FBevel      : TObjBevel;

    procedure   SetBevel(Value : TObjBevel);


  protected

//    procedure Resize; override;
//    procedure GetChange(Sender:TObject); override;
    procedure   PaintDC(DC: HDC); override;

  public

    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;

    function    IsEmpty: Boolean; override;

//    procedure   Assign(Source:TPersistent); override;

  published

    property   Bevel     : TObjBevel read FBevel    write SetBevel;

    property   CtrlFill;

    {*** ***}

    property Align;
//    property DragCursor;
//    property DragMode;

    property Color;
    property Enabled;
//    property ParentShowHint;
    property PopupMenu;
    Property ShowHint;
    Property Visible;

    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    {$IFDEF WIN32}
    property OnStartDrag;
    {$ENDIF}

//    property   OnMouseEnter;
//    property   OnMouseLeave;

  end;

{$ENDIF} { // PRG_INTERFACE }


{$IFDEF PRG_UNIT}               { ---------------------- }

{
// --------------------------------------------------------
//
// --------------------------------------------------------
}
Implementation

//Uses

//    SysUtils;                       { Default Units }

{$ENDIF} { // PRG_UNIT }

{$IFDEF PRG_IMPLEMENTATION}     { ---------------------- }

{
// --------------------------------------------------------
//  Default Constructor
// --------------------------------------------------------
}
constructor TBackground.Create(AOwner: TComponent);
begin
    inherited Create(AOwner);                   { Parent Create         }

    FBevel := TObjBevel.Create;
    FBevel.OnChange := GetChange;

    // SendToBack; ??

end;

{
// --------------------------------------------------------
//  Default Destructor
// --------------------------------------------------------
}
destructor TBackground.Destroy;
begin
    FBevel.OnChange := nil;
    FBevel.Free;

    inherited Destroy;
end;

{
// --------------------------------------------------------
//  Copy Bevel Data
// --------------------------------------------------------
}
procedure TBackground.SetBevel(Value : TObjBevel);
Begin
    FBevel.Assign(Value);
End;


{
// --------------------------------------------------------
// Return if Control is empty to draw
// --------------------------------------------------------
}
function TBackground.IsEmpty: Boolean;
begin
    Result := FBevel.IsEmpty and inherited IsEmpty;
end;

{
// --------------------------------------------------------
//  It correct Repaint Control
// --------------------------------------------------------
}
procedure TBackground.PaintDC(DC : HDC);
Var
    NewR : TRect;

Begin

    NewR := Rect(0,0,Width,Height);

    if (FCtrlFill <> nil) then
        FCtrlFill.Background.PaintDC(DC,FBevel.AdjustRect(NewR))
    else
        inherited PaintDC(DC);

    FBevel.PaintDC(DC,NewR);

end;


//procedure TBackground.Resize;
//begin
//    inherited Resize;
//    NotifyControls(CM_ColorChanged);
//end;

{$ENDIF} { // PRG_IMPLEMENTATION }

{$IFDEF PRG_UNIT}               { ---------------------- }
end.
{$ENDIF} { // PRG_UNIT }
