{ ------------------------------------------------------------- }
{                                                               }
{   Name:           XFBck_PE.pas                                }
{   Version:        V 0.2                                       }
{   Author:         Erick I. Jimenez Alvarado                   }
{   To contact:     erickj@usa.net                              }
{                   http://members.xoom.com/erickj              }
{                                                               }
{   Description:    Background property Editor                  }
{                                                               }
{   File Status:    COMPONETWARE ( like a FREEWARE but if you   }
{                   make a Componet or modify this please       }
{                   send or e-mail me this).                    }
{                                                               }
{   Last Upadated:  02/10/99                                    }
{                                                               }
{   History:                                                    }
{                                                               }
{    02/06/99   V0.1 -  First relase version                    }
{    02/10/99   V0.2 -  Add Property Style Editor               }
{                                                               }
{   Finally:        Sorry my bad, bad english and thanks for    }
{                   use my component.                           }
{                                                               }
{ ------------------------------------------------------------- }

{.$DEFINE PRG_UNIT}

{$IFDEF PRG_UNIT}               { ---------------------- }

{$DEFINE PRG_INTERFACE}
{$DEFINE PRG_IMPLEMENTATION}

{$I XTools.Inc } { Directives for all controls }

unit XFBck_PE;

interface

uses

 {$IFNDEF WIN32}
    WinTypes, WinProcs,             { Default Units }
 {$ELSE}
    Windows,                        { Default Unit  }
 {$ENDIF}  { // WIN32 }

  Graphics, Classes, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Spin, DsgnIntF,

  GraphExt,                         { My Unit       }
  XObjects,
  XCtrlStd;


{$ENDIF} { // PRG_UNIT }


{$IFDEF PRG_INTERFACE}          { ---------------------- }

{
// --------------------------------------------------------
// --------------------------------------------------------
}

type

{
// --------------------------------------------------------
//  FillBack Property Dialog Class
// --------------------------------------------------------
}

  TFillBackDlg = class(TForm)

    FillBack1: TFillBackground;
    FillBack2: TFillBackground;
    FillBack3: TFillBackground;
    Background0: TBackground;
    Background1: TBackground;
    Background2: TBackground;
    Background3: TBackground;
    About     : TButton;
    Btn_Ok    : TButton;
    Btn_Cancel: TButton;
    EnhBevel1: TEnhBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;

    procedure BackClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);

  private
    { Private declarations }
    FUpdate     : Boolean;

  public
    { Public declarations }
    FillStyle      : TObjBackgroundStyle;

    procedure UpdateCtrls;

  end;

{
// --------------------------------------------------------
//  Editor to Component GradientCtrl
// --------------------------------------------------------
}
  TFillBackComponentEditor = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index:Integer);override;
    function  GetVerb(Index: Integer): string; override;
    function  GetVerbCount: Integer; override;
  end;


{$IFDEF DFS_DELPHI_3_UP}
resourcestring
{$ELSE}
const
{$ENDIF}  { // DFS_DELPHI_3_UP }


    Str_FillBack_Title  = 'Fill Background Style';

const

  { // Backgroung Styles }
  CommonStrings: array [0..3] of String =  ('None', 'Gradient', 'Texture', 'Brush');


{
// --------------------------------------------------------
//  Util Function
// --------------------------------------------------------
}
function GetNewFillStyle(var FStyle: TObjBackgroundStyle): Boolean;

{$ENDIF} { // PRG_INTERFACE }



{$IFDEF PRG_UNIT}               { ---------------------- }


implementation

Uses
     SysUtils, TypInfo, SysUtlEx;

{$ENDIF} { // PRG_UNIT }


{$IFDEF PRG_IMPLEMENTATION}     { ---------------------- }

{$IFDEF PRG_UNIT}
{$R *.DFM}
{$ELSE}
{$R XFBck_PE.DFM}
{$ENDIF}

{
// --------------------------------------------------------
//  Default Constructor
// --------------------------------------------------------
}
procedure TFillBackDlg.FormCreate(Sender: TObject);
begin
    Caption := Str_FillBack_Title;

    Btn_Ok.Caption     := Str_Btn_Ok;
    Btn_Cancel.Caption := Str_Btn_Cancel;

    About.OnClick   := BackClick;
    About.Tag       := 4;

    Background0.OnClick := BackClick;
    Background0.Tag     := 0;
    Background1.OnClick := BackClick;
    Background1.Tag     := 1;
    Background2.OnClick := BackClick;
    Background2.Tag     := 2;
    Background3.OnClick := BackClick;
    Background3.Tag     := 3;

    with Label1 do
    begin
        Caption := CommonStrings[0];
        Tag     := 0;
        OnClick := BackClick;
    end;

    with Label2 do
    begin
        Caption := CommonStrings[1];
        Tag     := 1;
        OnClick := BackClick;
    end;

    with Label3 do
    begin
        Caption := CommonStrings[2];
        Tag     := 2;
        OnClick := BackClick;
    end;

    with Label4 do
    begin
        Caption := CommonStrings[3];
        Tag     := 3;
        OnClick := BackClick;
    end;

    FUpdate := False;
end;

{
// --------------------------------------------------------
//  Activate Handle
// --------------------------------------------------------
}
procedure TFillBackDlg.FormActivate(Sender: TObject);
begin
    if (not FUpdate) then
        FUpdate := True;
end;

{
// --------------------------------------------------------
//  Activate Handle
// --------------------------------------------------------
}
procedure TFillBackDlg.BackClick(Sender: TObject);
Var
    Idx : Integer;

begin

    if not (FUpdate) then
        exit;
    Idx := (Sender as TComponent).Tag;

    if (Idx = 4) then
    begin
        MessageDlg(Str_About_XTools,mtInformation,[mbOK],0);
        Exit;
    end;

    if (Integer(FillStyle) <> Idx) then
    begin
        FillStyle := TObjBackgroundStyle(Idx);
        UpdateCtrls;
    end;

end;


{
// --------------------------------------------------------
//  Reset all vars ( those are dummies)
// --------------------------------------------------------
}
procedure TFillBackDlg.UpdateCtrls;
begin

    // efbNone
    if (FillStyle = efbNone) then
        Background0.Bevel.OuterStyle := efsLowered
    else if (Background0.Bevel.OuterStyle = efsLowered) then
        Background0.Bevel.OuterStyle := efsRaised;

    if (FillStyle = efbGradient) then
        Background1.Bevel.OuterStyle := efsLowered
    else if (Background1.Bevel.OuterStyle = efsLowered) then
        Background1.Bevel.OuterStyle := efsRaised;

    if (FillStyle = efbTexture) then
        Background2.Bevel.OuterStyle := efsLowered
    else if (Background2.Bevel.OuterStyle = efsLowered) then
        Background2.Bevel.OuterStyle := efsRaised;

    if (FillStyle = efbBrush) then
        Background3.Bevel.OuterStyle := efsLowered
    else if (Background3.Bevel.OuterStyle = efsLowered) then
        Background3.Bevel.OuterStyle := efsRaised;

end;

{
// --------------------------------------------------------
//  Class TFillBackComponentEditor
// --------------------------------------------------------
}

{
// --------------------------------------------------------
//  Editor to Component GradientCtrl
// --------------------------------------------------------
}
procedure TFillBackComponentEditor.ExecuteVerb(Index: Integer);
var
    FStyle: TObjBackgroundStyle;
begin
    with TFillBackground(Component) do
        case Index of

            0  : MessageDlg(Str_About_XTools,mtInformation,[mbOK],0);
            1  : begin

                    FStyle := Background.BackStyle;

                    if not GetNewFillStyle(FStyle) then
                        exit;

                    Background.BackStyle := FStyle;

                 end;
            3  : if not GetNewGradient(Background.Gradient) then
                    exit;
            4  : if not GetNewObjBitmap(Background.Texture) then
                    exit;
//            5  : if not GetNewBrush(Background.Brush) then
//                    exit;
        end;

    Designer.Modified;
end;

{
// --------------------------------------------------------
//  Menu to Component TGradien
// --------------------------------------------------------
}
function TFillBackComponentEditor.GetVerb(Index: Integer): string;
begin
    case index of
        0: Result := 'About';
        1: Result := 'BackStyle (' + CommonStrings[Ord(TFillBackground(Component).Background.BackStyle)] + ')';
        2: Result := '-';
        3: Result := 'Gradient';
        4: Result := 'Texture';
        5: Result := 'Brush';
    end;
end;

{
// --------------------------------------------------------
//  Number of items in Menu to Component TGradient
// --------------------------------------------------------
}
function TFillBackComponentEditor.GetVerbCount: Integer;
begin
    Result := 6;
end;


{
// --------------------------------------------------------
//  Execute Dialog Property Editor and copy data
// --------------------------------------------------------
}
function GetNewFillStyle(var FStyle: TObjBackgroundStyle): Boolean;
begin

    Result  := False;

    with TFillBackDlg.Create(Application) do
    begin

      try

        FillStyle := FStyle;              { Copy Style            }

        UpdateCtrls;

        if (Showmodal = mrOK) then
        begin

          FStyle := FillStyle;            { Copy New Settings     }
          Result := True;

        end;

      finally

        Free;

      end;

    end;
end;

{$ENDIF} { // PRG_IMPLEMENTATION }

{$IFDEF PRG_UNIT}               { ---------------------- }
end.
{$ENDIF} { // PRG_UNIT }
